from diagrams import Cluster, Diagram, Edge
from diagrams.aws.network import ELB
from diagrams.onprem.monitoring import Grafana, Prometheus
from diagrams.onprem.logging import Fluentbit
from diagrams.onprem.database import Postgresql
from diagrams.generic.storage import Storage
from diagrams.k8s.network import SVC
from diagrams.k8s.storage import PVC
from diagrams.alibabacloud.application import LogService
from diagrams.onprem.network import Nginx
from diagrams.onprem.client import Client
from diagrams.gcp.analytics import Dataflow
from diagrams.onprem.ci import GitlabCI
from diagrams import Cluster, Diagram
from diagrams.aws.compute import ECS
from diagrams.aws.database import ElastiCache, RDS
from diagrams.aws.network import Route53
from diagrams.elastic.elasticsearch import ElasticSearch


with Diagram("SkillFactory Diploma", show=False):
    gitlab = GitlabCI("gitlab.com")
#    client = Client("Workstation")
#    client >> Edge(label="push") >> gitlab
    with Cluster("Yandex Cloud"):
        cl = LogService("Yandex Cloud Logging")
        with Cluster("Monitoring"):
            primary = Prometheus("Prometheus")
            secondary = Grafana("Grafana")
            primary - secondary
            GitlabCI("Gitlab Runner") << gitlab 

        with Cluster("K8s cluster"):
            Fluentbit("Fluentbit") >> cl 
            PVC("Storage") - Postgresql("DB") - SVC("Service") - ELB("load balancer") << primary
        
    